
#!/bin/sh
#	This is the POST2 script generated through XSL for BUILDID: 131
#
#	Required local variables
#
nPost=0
exit_status=0
slot=0
slot_message=""
blade=
logFile=/tmp/post2Log

#
#	getPlatform() function
#
getPlatform()
{
#
#	Should be pizzabox
#
if [ $1 == 0 ]
then
_abc=`/sbin/sin | \
    /bin/grep Platform | \
    /usr/bin/cut -d" " -f2 | \
    /usr/bin/cut -d"," -f1`

case $_abc in

"SWBD131" )
blade="CASTOR"
;;

"SWBD138" )
blade="BLACKBIRD"
;;

"SWBD155" )
blade="TOUCAN"
;;

"SWBD137" )
blade="CASTORT"
;;

"SWBD151" )
blade="DRACOT"
;;

"SWBD153" )
blade="RIGEL1"
;;

* )
blade="UNKNOWN"
;;
esac

else
#
#	Should be chassis
#
case $2 in

"135" )
blade="CASTOR"
;;

"146" )
blade="BLACKBIRD"
;;

"164" )
blade="TOUCAN"
;;

"145" )
blade="CASTORT"
;;

"157" )
blade="DRACOT"
;;

"159" )
blade="RIGEL1"
;;

* )
blade="UNKNOWN"
;;
esac

fi
}

#
#	Post_cleanup() function
#
post_cleanup()
{
    if [ $?child ]
    then
        /bin/kill $child
    fi

    #
    #  display all performed test result
    #
    _current_time=`/bin/date \+\%s`
    _date=`/bin/date`
    _duration=`/usr/bin/expr $_current_time - $startTime`
    _minute=`/usr/bin/expr $_duration / 60`
    _hour=`/usr/bin/expr $_minute / 60`
    _sec=`/usr/bin/expr $_duration % 60`
    _minute=`/usr/bin/expr $_minute % 60`
    /bin/echo "POST2:$slot_message POST2 script has been ABORTED $_date took ($_hour:$_minute:$_sec)"
    /bin/echo "POST2:$slot_message POST2 script has been ABORTED $_date took ($_hour:$_minute:$_sec)" >> $logFile.$slot
    /bin/echo "POST2:$slot_message Completed totally $nPost diagnostic tests..."
    /bin/echo "POST2:$slot_message Completed totally $nPost diagnostic tests..." >> $logFile.$slot
    if [ $blade = BLACKBIRD ]; then  $smmi -reg DIAG_STATUS_ID -data POST2_FAILINIT; fi
    if [ $blade = TOUCAN ]; then  $smmi -reg DIAG_STATUS_ID -data POST2_FAILINIT; fi
    exit 1
}

#
#	checkStatus of the command and setup exit_status variable
#
checkStatus()
{
    export child=$!
    wait $child
    rval=$?

    case $rval in
    0 )
        status=PASSED
        ;;
    * )
        status=FAILED
        exit_status=`/usr/bin/expr $exit_status + 1`
		if [ $blade = BLACKBIRD ]; then  $smmi -reg DIAG_STATUS_ID -data POST2_FAIL1
		    exit $exit_status
		fi
	if [ $blade = TOUCAN ]; then  $smmi -reg DIAG_STATUS_ID -data POST2_FAIL1
		    exit $exit_status
	fi
        ;;
    esac

    if [ $rval -gt 127 ]
    then
        rval=`/usr/bin/expr $rval - 256`
    fi

    /bin/echo "POST2:$slot_message Test: $* Status: $status (exit_status $rval)..." >> $logFile.$slot
}

trap "" 2
trap post_cleanup INT TERM KILL

#
#   Fill slot variable from FABOS_SLOTNO
#
if [ $?FABOS_SLOTNO ]
then
    slot=$FABOS_SLOTNO
fi

#
#   Fill bladeId variable from Param passed
#
if [ -n "$1" ] 
then
    bladeId=$1
fi
/bin/echo "POST2: bladeid is $bladeId" >> $logFile.$slot
#

#
#   Identify blade here
#
getPlatform $slot $bladeId

#
#   Cleanup the old log file
#
if [ -f $logFile.$slot ]
then
    /bin/rm $logFile.$slot
fi

if [ $blade = UNKNOWN ]; then
	/bin/echo "POST2: Blade is UNKNOWN Slot=$slot Blade=$blade" >> $logFile.$slot
    #   Skip running test on unknown blade and enable diagd to transition the blade
    exit 0
fi


#
#	Export Environment variables
#
DIAG_POST=1 ; export DIAG_POST
DIAG_USR_FAILLIM=1 ; export DIAG_USR_FAILLIM

#
#	Sourcing diagcommon.sh
#
home="/fabos/share"
util="diagcommon.sh"
ok=0
for f in "./$util" "$FABOSHOME/share/$util" "$home/$util" ; do
    if [ -r $f ] ; then
        . $f
        ok=1
        break;
    fi
done
if [ $ok -ne 1 ] ; then
	/bin/echo "POST2: Could not locate $util; Aborting"
	/bin/echo "POST2: Could not locate $util; Aborting" >> $logFile.$slot
	exit 3
fi

#
#	Check Pizzabox/Chassis variant during runtime; isMultiBlade is defined in diagcommon.sh
#	Also setup slot_message variable
#
multiBlade=`isMultiBlade`
if [ $multiBlade = TRUE ]
then
	slot_message="Slot `get_logical_slot $slot`"
	export syntax="$0 -slot [slot] postScript"
else
	export syntax="$0 postScript"
fi

#
#   Add blade identifiers to our Log file for debugging purpose; Zero means pizzabox
#
/bin/echo "POST2:$slot_message running for platform: $blade, Slot#: $slot, Logfile: $logFile"  >> $logFile.$slot

#
#	Setup commandPaths
#
cmd=`commandPath exec_diag`
setdbg=`commandPath setdbg`

if [ $blade = BLACKBIRD ]; then
smmi=`commandPath setmmi`
gmmi=`commandPath getmmi`

state=`$gmmi -reg "POST CONFIG" | cut -d" " -f2`
case $state in
    0) $smmi -reg DIAG_STATUS_ID -data INIT_COMPLETE
        exit 0;;
    *) ;;
esac
fi

if [ $blade = TOUCAN ]; then
smmi=`commandPath setmmi`
gmmi=`commandPath getmmi`

state=`$gmmi -reg "POST CONFIG" | cut -d" " -f2`
case $state in
    0) $smmi -reg DIAG_STATUS_ID -data INIT_COMPLETE
        exit 0;;
    *) ;;
esac
fi

$setdbg DIAG 1
#
#       Start message to the user
#
startTime=`/bin/date \+\%s`
_date=`/bin/date`
/bin/echo "" >> $logFile.$slot
/bin/echo "POST2:$slot_message started running $_date"
/bin/echo "POST2:$slot_message started running $_date" >> $logFile.$slot
			     

#
#	Reset Error on each port 
# 
/bin/echo "POST2:$slot_message Clearing errors" >> $logFile.$slot
$cmd diagclearerror $slot > /dev/null

#
#	Detect and handle bplb_mode
#
bplb_mode=`getConfig diag.mode.bplb 2 0`
if [ "$bplb_mode" != "0" ]
then
	/bin/echo "POST2:$slot_message BPLB mode is ON"
	/bin/echo "$slot_message BPLB mode is ON" >> $logFile.$slot
fi

#
#   Execute command-set as per platform
#
case $blade in

#
#	Platform: Platform name not found
#
" " )
echo "POST2 Script error: Could not determine blade (Parameters: Slot=$slot, Blade=$blade). Aborting" >> $logFile.$slot
exit 4
;;

#
#	Platform: CASTOR
#
"CASTOR" )

#
#   Test: portloopbacktest -dports 1-48 (10G)
#

cmd3=`commandPath exec_diag`

nPost=`/usr/bin/expr $nPost + 1`
/bin/echo "POST2:$slot_message Test #$nPost - Running portloopbacktest -dports 1-48 (10G)" >> $logFile.$slot
/bin/echo "POST2:$slot_message Test #$nPost - Running portloopbacktest -dports 1-48 (10G)"
$cmd3 portloopbacktest -nframes 4 -lb_mode 2 -dports 1-48 -spd_mode 10 2>&1 >> $logFile.$slot &
checkStatus portloopbacktest -nframes 4 -lb_mode 2 -dports 1-48 -spd_mode 10 2>&1
#
#   Test: portloopbacktest -dports 49-64 (40G)
#

cmd3=`commandPath exec_diag`

nPost=`/usr/bin/expr $nPost + 1`
/bin/echo "POST2:$slot_message Test #$nPost - Running portloopbacktest -dports 49-64 (40G)" >> $logFile.$slot
/bin/echo "POST2:$slot_message Test #$nPost - Running portloopbacktest -dports 49-64 (40G)"
$cmd3 portloopbacktest -nframes 4 -lb_mode 2 -dports 49-64 -spd_mode 40 2>&1 >> $logFile.$slot &
checkStatus portloopbacktest -nframes 4 -lb_mode 2 -dports 49-64 -spd_mode 40 2>&1
#
#   Test: Diagcleanup
#

cmd3=`commandPath exec_diag`

/bin/echo "POST2:$slot_message Test - Running Diagcleanup (Silent)" >> $logFile.$slot
$cmd3 usdsetupfortest --slot $slot -test_step 3 -post 1 2>&1 >> $logFile.$slot
status_local=$?

if [ $status_local -ne 0 ]
then
    exit_status=`/usr/bin/expr $exit_status + 1`
fi

;;

#
#	Platform: BLACKBIRD
#
"BLACKBIRD" )

cmd3=`commandPath exec_diag`

#
$cmd usdsetupfortest --slot $slot -test_step 2 -post 1 >> $logFile.$slot
#

cmd3=`commandPath exec_diag`

#
$smmi -reg DIAG_STATUS_ID -data POST2_INIT
#

#
#   Test: portloopbacktest -dports 1-56 (10G)
#

cmd3=`commandPath exec_diag`

nPost=`/usr/bin/expr $nPost + 1`
/bin/echo "POST2:$slot_message Test #$nPost - Running portloopbacktest -dports 1-56 (10G)" >> $logFile.$slot
/bin/echo "POST2:$slot_message Test #$nPost - Running portloopbacktest -dports 1-56 (10G)"
$cmd3 portloopbacktest -nframes 4 -lb_mode 2 -dports 1-56 -spd_mode 10 2>&1 >> $logFile.$slot &
checkStatus portloopbacktest -nframes 4 -lb_mode 2 -dports 1-56 -spd_mode 10 2>&1
#
#   Test: portloopbacktest -dports 57-64 (40G)
#

cmd3=`commandPath exec_diag`

nPost=`/usr/bin/expr $nPost + 1`
/bin/echo "POST2:$slot_message Test #$nPost - Running portloopbacktest -dports 57-64 (40G)" >> $logFile.$slot
/bin/echo "POST2:$slot_message Test #$nPost - Running portloopbacktest -dports 57-64 (40G)"
$cmd3 portloopbacktest -nframes 4 -lb_mode 2 -dports 57-64 -spd_mode 40 2>&1 >> $logFile.$slot &
checkStatus portloopbacktest -nframes 4 -lb_mode 2 -dports 57-64 -spd_mode 40 2>&1
#
#   Test: Diagcleanup
#

cmd3=`commandPath exec_diag`

/bin/echo "POST2:$slot_message Test - Running Diagcleanup (Silent)" >> $logFile.$slot
$cmd3 usdsetupfortest --slot $slot -test_step 3 -post 1 2>&1 >> $logFile.$slot
status_local=$?

if [ $status_local -ne 0 ]
then
    exit_status=`/usr/bin/expr $exit_status + 1`
fi

cmd3=`commandPath exec_diag`

if [ $status_local -ne 0 ]
then

#
$smmi -reg DIAG_STATUS_ID -data POST2_FAIL3
#

fi

;;

#
#	Platform: TOUCAN
#
"TOUCAN" )

cmd3=`commandPath exec_diag`

#
$cmd usdsetupfortest --slot $slot -test_step 2 -post 1 >> $logFile.$slot
#

cmd3=`commandPath exec_diag`

#
$smmi -reg DIAG_STATUS_ID -data POST2_INIT
#

#
#   Test: portloopbacktest -dports 1-44 (10G)
#

cmd3=`commandPath exec_diag`

nPost=`/usr/bin/expr $nPost + 1`
/bin/echo "POST2:$slot_message Test #$nPost - Running portloopbacktest -dports 1-44 (10G)" >> $logFile.$slot
/bin/echo "POST2:$slot_message Test #$nPost - Running portloopbacktest -dports 1-44 (10G)"
$cmd3 portloopbacktest -nframes 4 -lb_mode 2 -dports 1-44 -spd_mode 10 2>&1 >> $logFile.$slot &
checkStatus portloopbacktest -nframes 4 -lb_mode 2 -dports 1-44 -spd_mode 10 2>&1
#
#   Test: portloopbacktest -dports 45-60 (40G)
#

cmd3=`commandPath exec_diag`

nPost=`/usr/bin/expr $nPost + 1`
/bin/echo "POST2:$slot_message Test #$nPost - Running portloopbacktest -dports 45-60 (40G)" >> $logFile.$slot
/bin/echo "POST2:$slot_message Test #$nPost - Running portloopbacktest -dports 45-60 (40G)"
$cmd3 portloopbacktest -nframes 4 -lb_mode 2 -dports 45-60 -spd_mode 40 2>&1 >> $logFile.$slot &
checkStatus portloopbacktest -nframes 4 -lb_mode 2 -dports 45-60 -spd_mode 40 2>&1
#
#   Test: Diagcleanup
#

cmd3=`commandPath exec_diag`

/bin/echo "POST2:$slot_message Test - Running Diagcleanup (Silent)" >> $logFile.$slot
$cmd3 usdsetupfortest --slot $slot -test_step 3 -post 1 2>&1 >> $logFile.$slot
status_local=$?

if [ $status_local -ne 0 ]
then
    exit_status=`/usr/bin/expr $exit_status + 1`
fi

cmd3=`commandPath exec_diag`

if [ $status_local -ne 0 ]
then

#
$smmi -reg DIAG_STATUS_ID -data POST2_FAIL3
#

fi

;;

#
#	Platform: CASTORT
#
"CASTORT" )

#
#   Test: portloopbacktest -dports 1-48 (10G)
#

cmd3=`commandPath exec_diag`

nPost=`/usr/bin/expr $nPost + 1`
/bin/echo "POST2:$slot_message Test #$nPost - Running portloopbacktest -dports 1-48 (10G)" >> $logFile.$slot
/bin/echo "POST2:$slot_message Test #$nPost - Running portloopbacktest -dports 1-48 (10G)"
$cmd3 portloopbacktest -nframes 4 -lb_mode 2 -dports 1-48 -spd_mode 10 2>&1 >> $logFile.$slot &
checkStatus portloopbacktest -nframes 4 -lb_mode 2 -dports 1-48 -spd_mode 10 2>&1
#
#   Test: portloopbacktest -dports 49-64 (40G)
#

cmd3=`commandPath exec_diag`

nPost=`/usr/bin/expr $nPost + 1`
/bin/echo "POST2:$slot_message Test #$nPost - Running portloopbacktest -dports 49-64 (40G)" >> $logFile.$slot
/bin/echo "POST2:$slot_message Test #$nPost - Running portloopbacktest -dports 49-64 (40G)"
$cmd3 portloopbacktest -nframes 4 -lb_mode 2 -dports 49-64 -spd_mode 40 2>&1 >> $logFile.$slot &
checkStatus portloopbacktest -nframes 4 -lb_mode 2 -dports 49-64 -spd_mode 40 2>&1
#
#   Test: Diagcleanup
#

cmd3=`commandPath exec_diag`

/bin/echo "POST2:$slot_message Test - Running Diagcleanup (Silent)" >> $logFile.$slot
$cmd3 usdsetupfortest --slot $slot -test_step 3 -post 1 2>&1 >> $logFile.$slot
status_local=$?

if [ $status_local -ne 0 ]
then
    exit_status=`/usr/bin/expr $exit_status + 1`
fi

;;

#
#	Platform: DRACOT
#
"DRACOT" )

#
#   Test: portloopbacktest (1G)
#

cmd3=`commandPath exec_diag`

nPost=`/usr/bin/expr $nPost + 1`
/bin/echo "POST2:$slot_message Test #$nPost - Running portloopbacktest (1G)" >> $logFile.$slot
/bin/echo "POST2:$slot_message Test #$nPost - Running portloopbacktest (1G)"
$cmd3 portloopbacktest -nframes 4 -lb_mode 2 -dports 1-48 -spd_mode 1 2>&1 >> $logFile.$slot &
checkStatus portloopbacktest -nframes 4 -lb_mode 2 -dports 1-48 -spd_mode 1 2>&1
#
#   Test: portloopbacktest (40G)
#

cmd3=`commandPath exec_diag`

nPost=`/usr/bin/expr $nPost + 1`
/bin/echo "POST2:$slot_message Test #$nPost - Running portloopbacktest (40G)" >> $logFile.$slot
/bin/echo "POST2:$slot_message Test #$nPost - Running portloopbacktest (40G)"
$cmd3 portloopbacktest -nframes 4 -lb_mode 2 -dports 49-64 2>&1 >> $logFile.$slot &
checkStatus portloopbacktest -nframes 4 -lb_mode 2 -dports 49-64 2>&1
#
#   Test: Diagcleanup
#

cmd3=`commandPath exec_diag`

/bin/echo "POST2:$slot_message Test - Running Diagcleanup (Silent)" >> $logFile.$slot
$cmd3 usdsetupfortest --slot $slot -test_step 3 -post 1 2>&1 >> $logFile.$slot
status_local=$?

if [ $status_local -ne 0 ]
then
    exit_status=`/usr/bin/expr $exit_status + 1`
fi

;;

#
#	Platform: RIGEL1
#
"RIGEL1" )

cmd3=`commandPath exec_diag`

#
/bin/touch /tmp/diag_cbr2_gpll_init 2>&1
#

#
#   Test: portloopbacktest (10G)
#

cmd3=`commandPath exec_diag`

nPost=`/usr/bin/expr $nPost + 1`
/bin/echo "POST2:$slot_message Test #$nPost - Running portloopbacktest (10G)" >> $logFile.$slot
/bin/echo "POST2:$slot_message Test #$nPost - Running portloopbacktest (10G)"
$cmd3 portloopbacktest -nframes 4 -txburst 1 -lb_mode 2 -dports 1-144 -spd_mode 10 2>&1 >> $logFile.$slot &
checkStatus portloopbacktest -nframes 4 -txburst 1 -lb_mode 2 -dports 1-144 -spd_mode 10 2>&1
cmd3=`commandPath exec_diag`

#
/bin/rm /tmp/diag_cbr2_gpll_init 2>&1
#

cmd3=`commandPath exec_diag`

#
/bin/touch /tmp/post_40g 2>&1
#

#
#   Test: portloopbacktest (40G)
#

cmd3=`commandPath exec_diag`

nPost=`/usr/bin/expr $nPost + 1`
/bin/echo "POST2:$slot_message Test #$nPost - Running portloopbacktest (40G)" >> $logFile.$slot
/bin/echo "POST2:$slot_message Test #$nPost - Running portloopbacktest (40G)"
$cmd3 portloopbacktest -nframes 4 -txburst 1 -lb_mode 2 -dports 1-144 -spd_mode 40 2>&1 >> $logFile.$slot &
checkStatus portloopbacktest -nframes 4 -txburst 1 -lb_mode 2 -dports 1-144 -spd_mode 40 2>&1
cmd3=`commandPath exec_diag`

#
/bin/rm /tmp/post_40g 2>&1
#

#
#   Test: Diagcleanup
#

cmd3=`commandPath exec_diag`

/bin/echo "POST2:$slot_message Test - Running Diagcleanup (Silent)" >> $logFile.$slot
$cmd3 usdsetupfortest --slot $slot -test_step 3 -post 1 2>&1 >> $logFile.$slot
status_local=$?

if [ $status_local -ne 0 ]
then
    exit_status=`/usr/bin/expr $exit_status + 1`
fi

;;

esac

#
#	Display completed test count
#
/bin/echo "POST2:$slot_message Completed totally $nPost diagnostic tests..." >> $logFile.$slot

#
#	If exit_status > 0, report FAILED
#
if [ $exit_status -ne 0 ]
then
    status=FAILED
    #	copy the POST log to permanent storage for FA
    /fabos/link_bin/sync
    /bin/cp $logFile.$slot /var/log
    /fabos/link_bin/sync
else
    status=PASSED
fi

#
#	Display final exit_status
#
_current_time=`/bin/date \+\%s`
_date=`/bin/date`
_duration=`/usr/bin/expr $_current_time - $startTime`
_minute=`/usr/bin/expr $_duration / 60`
_hour=`/usr/bin/expr $_minute / 60`
_sec=`/usr/bin/expr $_duration % 60`
_minute=`/usr/bin/expr $_minute % 60`
/bin/echo "POST2:$slot_message Script $status with exit status of $exit_status $_date took ($_hour:$_minute:$_sec)"
/bin/echo "POST2:$slot_message Script $status with exit_status of $exit_status $_date took ($_hour:$_minute:$_sec)" >> $logFile.$slot
/bin/echo "" >> $logFile.$slot

#
#	Return with the error code (Zero shows no error)
#
exit $exit_status
